'''
Created on 09.02.2014
@author: Dorjee Tamang
'''
            
class Cluster(object):
    
    def __init__(self, sequence, unique):
        self.unique = unique
        self.sequence = sequence
        self._dict = self.create_dict(sequence)
    
    @property
    def format(self):
        """Get sequence format"""
        format = "plain"
        if ">" in self.sequence:
            format = "fasta"
        return format
    
    def create_dict(self, sequence):
        d = {}
        if self.format == 'plain':
            num = 1
            for i, peptide in enumerate(self.sequence.split()):
                if self.unique == 'on':
                    if peptide not in d.values():
                        d[i+1] = peptide
                else: d[i+1] = peptide
        elif self.format == 'fasta':
            input_sequences = self.sequence.split(">")
            for item in map(lambda s: s.strip(), filter(None, input_sequences)):
                name, peptide = item.splitlines()
                if self.unique == 'on':
                    if peptide not in d.values():
                        d[name] = peptide
                else: d[name] = peptide
        return d
    
    @property
    def get_dict(self):
        """Get individual sequence ID"""
        return self._dict
